<?php

/**
 * offen-siv PHP-Wettbewerb
 *
 * Die Aufgabe lautet: Schreibe ein PHP-Programm, dass eine - gegebene -
 * BMP-Grafik mglichst kreativ umwandelt oder anwendet. Das Ergebnis muss
 * keine Grafik sein. Denkbar wre neben klassischen Bildverzerrungen z.B. die
 * Konvertierung des Bildinhaltes in eine - wie auch immer geartete -
 * HTML-Entsprechung, die Berechnung von Histogrammen und Statistiken oder
 * auch die Verwendung des unvernderten Bildes als Baustein fr ganz neue
 * Konstruktionen.
 *
 * Unsere Jury wird die Kreativitt des Beitrages unter zwei Gesichtspunkten
 * bewerten:
 *
 * a) Knstlerische Kreativitt - hier wird der Effekt bewertet, also das, was
 *    das Programm ausgibt. Das muss kein Kunstwerk im klassischen Sinne sein.
 *    Eine kreative textuelle Interpretation wird ebenso gut bewertet.
 *
 * b) Programmtechnische Kreativitt - hier geht es um elegante Code-Strukturen
 *    und den trickreichen, aber trotzdem lesbaren und nachvollziehbaren
 *    Einsatz der Mglichkeiten von PHP. Bonuspunkte gibt es, wenn der Beitrag
 *    auf die auf der GD-Bibliothek basierenden Funktionen (imagecreate() usw.)
 *    verzichtet.
 *
 * Sende deinen Beitrag per E-Mail an offen-siv@web.de
 * Einsendeschlu ist Sonntag, der 11. Juli 2004.
 * Die Beitrge werden anschlieend auf unserer Website verffentlicht.
 *
 * Es winkt ein Bcher-Gutschein im Wert von 30 Euro.
 *
 * www.hs-zigr.de/studenten
 */

// Hier noch ein sehr, sehr einfaches Beispiel-Programm fr den Start:

$fp = fopen("offen-siv_src.bmp", "rb");

fseek($fp, 18);
$width = fgetc($fp);
$width = ord($width);

fseek($fp, 22);
$height = fgetc($fp);
$height = ord($height);

// Maybe fscanf() or unpack() are worth a look.

echo $width . " multiplied with " . $height . " is ";
echo $width * $height;
echo ".";

fseek($fp, 56);
$rgb['r'] = ord(fgetc($fp));
fseek($fp, 55);
$rgb['g'] = ord(fgetc($fp));
fseek($fp, 54);
$rgb['b'] = ord(fgetc($fp));

$color = "rgb(" . implode(", ", $rgb) . ")";

echo "<p>The color of the bottom left pixel is ";
echo "<span style=\"background-color:" . $color . "\">";
echo $color;
echo "</span>.";

?>